Ruby: prism/util/pm_char.h File Reference

Ruby 3.4.6p54 (2025-09-16 revision dbd83256b1cec76c69756ecb8758b9e1079833de)

Functions
pm_char.h File Reference

Functions for working with characters and strings. More...

`#include "prism/defines.h"`
`#include "prism/util/pm_newline_list.h"`
`#include <stdbool.h>`
`#include <stddef.h>`

Go to the source code of this file.

## Functions
size_t | pm_strspn_whitespace (const uint8_t *string, ptrdiff_t length)
| Returns the number of characters at the start of the string that are whitespace.
size_t | pm_strspn_whitespace_newlines (const uint8_t *string, ptrdiff_t length, pm_newline_list_t *newline_list)
| Returns the number of characters at the start of the string that are whitespace while also tracking the location of each newline.
size_t | pm_strspn_inline_whitespace (const uint8_t *string, ptrdiff_t length)
| Returns the number of characters at the start of the string that are inline whitespace.
size_t | pm_strspn_decimal_digit (const uint8_t *string, ptrdiff_t length)
| Returns the number of characters at the start of the string that are decimal digits.
size_t | pm_strspn_hexadecimal_digit (const uint8_t *string, ptrdiff_t length)
| Returns the number of characters at the start of the string that are hexadecimal digits.
size_t | pm_strspn_octal_number (const uint8_t *string, ptrdiff_t length, const uint8_t **invalid)
| Returns the number of characters at the start of the string that are octal digits or underscores.
size_t | pm_strspn_decimal_number (const uint8_t *string, ptrdiff_t length, const uint8_t **invalid)
| Returns the number of characters at the start of the string that are decimal digits or underscores.
size_t | pm_strspn_hexadecimal_number (const uint8_t *string, ptrdiff_t length, const uint8_t **invalid)
| Returns the number of characters at the start of the string that are hexadecimal digits or underscores.
size_t | pm_strspn_regexp_option (const uint8_t *string, ptrdiff_t length)
| Returns the number of characters at the start of the string that are regexp options.
size_t | pm_strspn_binary_number (const uint8_t *string, ptrdiff_t length, const uint8_t **invalid)
| Returns the number of characters at the start of the string that are binary digits or underscores.
bool | pm_char_is_whitespace (const uint8_t b)
| Returns true if the given character is a whitespace character.
bool | pm_char_is_inline_whitespace (const uint8_t b)
| Returns true if the given character is an inline whitespace character.
bool | pm_char_is_binary_digit (const uint8_t b)
| Returns true if the given character is a binary digit.
bool | pm_char_is_octal_digit (const uint8_t b)
| Returns true if the given character is an octal digit.
bool | pm_char_is_decimal_digit (const uint8_t b)
| Returns true if the given character is a decimal digit.
bool | pm_char_is_hexadecimal_digit (const uint8_t b)
| Returns true if the given character is a hexadecimal digit.

## Detailed Description

Functions for working with characters and strings.

Definition in file pm_char.h.

## Function Documentation

## ◆ pm_char_is_binary_digit()

bool pm_char_is_binary_digit | ( | const uint8_t | b | ) |

Returns true if the given character is a binary digit.

Parameters

  b | The character to check.

Returns
  True if the given character is a binary digit.

Definition at line 279 of file pm_char.c.

## ◆ pm_char_is_decimal_digit()

bool pm_char_is_decimal_digit | ( | const uint8_t | b | ) |

Returns true if the given character is a decimal digit.

Parameters

  b | The character to check.

Returns
  True if the given character is a decimal digit.

Definition at line 295 of file pm_char.c.

## ◆ pm_char_is_hexadecimal_digit()

bool pm_char_is_hexadecimal_digit | ( | const uint8_t | b | ) |

Returns true if the given character is a hexadecimal digit.

Parameters

  b | The character to check.

Returns
  True if the given character is a hexadecimal digit.

Definition at line 303 of file pm_char.c.

## ◆ pm_char_is_inline_whitespace()

bool pm_char_is_inline_whitespace | ( | const uint8_t | b | ) |

Returns true if the given character is an inline whitespace character.

Parameters

  b | The character to check.

Returns
  True if the given character is an inline whitespace character.

Definition at line 141 of file pm_char.c.

## ◆ pm_char_is_octal_digit()

bool pm_char_is_octal_digit | ( | const uint8_t | b | ) |

Returns true if the given character is an octal digit.

Parameters

  b | The character to check.

Returns
  True if the given character is an octal digit.

Definition at line 287 of file pm_char.c.

## ◆ pm_char_is_whitespace()

bool pm_char_is_whitespace | ( | const uint8_t | b | ) |

Returns true if the given character is a whitespace character.

Parameters

  b | The character to check.

Returns
  True if the given character is a whitespace character.

Definition at line 133 of file pm_char.c.

## ◆ pm_strspn_binary_number()

size_t pm_strspn_binary_number | ( | const uint8_t * | string,
|  | ptrdiff_t | length,
|  | const uint8_t ** | invalid )

Returns the number of characters at the start of the string that are binary digits or underscores.

Disallows searching past the given maximum number of characters.

If multiple underscores are found in a row or if an underscore is found at the end of the number, then the invalid pointer is set to the index of the first invalid underscore.

Parameters

  string | The string to search.
  length | The maximum number of characters to search.
  invalid | The pointer to set to the index of the first invalid underscore.

Returns
  The number of characters at the start of the string that are binary digits or underscores.

Disallows searching past the given maximum number of characters.

If multiple underscores are found in a row or if an underscore is found at the end of the number, then the invalid pointer is set to the index of the first invalid underscore.

Definition at line 202 of file pm_char.c.

## ◆ pm_strspn_decimal_digit()

size_t pm_strspn_decimal_digit | ( | const uint8_t * | string,
|  | ptrdiff_t | length )

Returns the number of characters at the start of the string that are decimal digits.

Disallows searching past the given maximum number of characters.

Parameters

  string | The string to search.
  length | The maximum number of characters to search.

Returns
  The number of characters at the start of the string that are decimal digits.

Disallows searching past the given maximum number of characters.

Definition at line 225 of file pm_char.c.

## ◆ pm_strspn_decimal_number()

size_t pm_strspn_decimal_number | ( | const uint8_t * | string,
|  | ptrdiff_t | length,
|  | const uint8_t ** | invalid )

Returns the number of characters at the start of the string that are decimal digits or underscores.

Disallows searching past the given maximum number of characters.

If multiple underscores are found in a row or if an underscore is found at the end of the number, then the invalid pointer is set to the index of the first invalid underscore.

Parameters

  string | The string to search.
  length | The maximum number of characters to search.
  invalid | The pointer to set to the index of the first invalid underscore.

Returns
  The number of characters at the start of the string that are decimal digits or underscores.

Disallows searching past the given maximum number of characters.

If multiple underscores are found in a row or if an underscore is found at the end of the number, then the invalid pointer is set to the index of the first invalid underscore

Definition at line 239 of file pm_char.c.

## ◆ pm_strspn_hexadecimal_digit()

size_t pm_strspn_hexadecimal_digit | ( | const uint8_t * | string,
|  | ptrdiff_t | length )

Returns the number of characters at the start of the string that are hexadecimal digits.

Disallows searching past the given maximum number of characters.

Parameters

  string | The string to search.
  length | The maximum number of characters to search.

Returns
  The number of characters at the start of the string that are hexadecimal digits.

Disallows searching past the given maximum number of characters.

Definition at line 249 of file pm_char.c.

## ◆ pm_strspn_hexadecimal_number()

size_t pm_strspn_hexadecimal_number | ( | const uint8_t * | string,
|  | ptrdiff_t | length,
|  | const uint8_t ** | invalid )

Returns the number of characters at the start of the string that are hexadecimal digits or underscores.

Disallows searching past the given maximum number of characters.

If multiple underscores are found in a row or if an underscore is found at the end of the number, then the invalid pointer is set to the index of the first invalid underscore.

Parameters

  string | The string to search.
  length | The maximum number of characters to search.
  invalid | The pointer to set to the index of the first invalid underscore.

Returns
  The number of characters at the start of the string that are hexadecimal digits or underscores.

Disallows searching past the given maximum number of characters.

If multiple underscores are found in a row or if an underscore is found at the end of the number, then the invalid pointer is set to the index of the first invalid underscore.

Definition at line 263 of file pm_char.c.

## ◆ pm_strspn_inline_whitespace()

size_t pm_strspn_inline_whitespace | ( | const uint8_t * | string,
|  | ptrdiff_t | length )

Returns the number of characters at the start of the string that are inline whitespace.

Disallows searching past the given maximum number of characters.

Parameters

  string | The string to search.
  length | The maximum number of characters to search.

Returns
  The number of characters at the start of the string that are inline whitespace.

Disallows searching past the given maximum number of characters.

Definition at line 108 of file pm_char.c.

## ◆ pm_strspn_octal_number()

size_t pm_strspn_octal_number | ( | const uint8_t * | string,
|  | ptrdiff_t | length,
|  | const uint8_t ** | invalid )

Returns the number of characters at the start of the string that are octal digits or underscores.

Disallows searching past the given maximum number of characters.

If multiple underscores are found in a row or if an underscore is found at the end of the number, then the invalid pointer is set to the index of the first invalid underscore.

Parameters

  string | The string to search.
  length | The maximum number of characters to search.
  invalid | The pointer to set to the index of the first invalid underscore.

Returns
  The number of characters at the start of the string that are octal digits or underscores.

Disallows searching past the given maximum number of characters.

If multiple underscores are found in a row or if an underscore is found at the end of the number, then the invalid pointer is set to the index of the first invalid underscore.

Definition at line 216 of file pm_char.c.

## ◆ pm_strspn_regexp_option()

size_t pm_strspn_regexp_option | ( | const uint8_t * | string,
|  | ptrdiff_t | length )

Returns the number of characters at the start of the string that are regexp options.

Disallows searching past the given maximum number of characters.

Parameters

  string | The string to search.
  length | The maximum number of characters to search.

Returns
  The number of characters at the start of the string that are regexp options.

Disallows searching past the given maximum number of characters.

Definition at line 117 of file pm_char.c.

## ◆ pm_strspn_whitespace()

size_t pm_strspn_whitespace | ( | const uint8_t * | string,
|  | ptrdiff_t | length )

Returns the number of characters at the start of the string that are whitespace.

Disallows searching past the given maximum number of characters.

Parameters

  string | The string to search.
  length | The maximum number of characters to search.

Returns
  The number of characters at the start of the string that are whitespace.

Disallows searching past the given maximum number of characters.

Definition at line 76 of file pm_char.c.

## ◆ pm_strspn_whitespace_newlines()

size_t pm_strspn_whitespace_newlines | ( | const uint8_t * | string,
|  | ptrdiff_t | length,
|  | pm_newline_list_t * | newline_list )

Returns the number of characters at the start of the string that are whitespace while also tracking the location of each newline.

Disallows searching past the given maximum number of characters.

Parameters

  string | The string to search.
  length | The maximum number of characters to search.
  newline_list | The list of newlines to populate.

Returns
  The number of characters at the start of the string that are whitespace.

Disallows searching past the given maximum number of characters.

Definition at line 86 of file pm_char.c.